///////////////////////////////////////////////////////////
//  DumpMemory.cpp
//  Implementation of the Class DumpMemory
//  Created on:      14-2-2009 21:41:16
//  Original author: Ueno
///////////////////////////////////////////////////////////

#include "Application/Tibi8Monitor/DumpMemory.h"
#include "Common/BasicType/util.h"
//#include "SCIBase.h"
//#include "HexDump.h"
#include "Common/BasicType/ValueToStringConverter.h"

using Application::Tibi8Monitor::DumpMemory;


DumpMemory::DumpMemory(){}
DumpMemory::~DumpMemory(){}

bool DumpMemory::check(const Common::BasicType::Bytes* command){
	bool bRet=false;
	if(command->size()>=1)
	{
		if( ( (*command)[0]=='d') || ((*command)[0]=='D'))
		{
		bRet=true;
		}
	}
	return bRet;
}


void DumpMemory::execute(Unit::Communication::Com* com, Common::BasicType::Bytes* command){
//	com->send(command,false);
#if defined(MALLOC_DEBUG)
	dumpMallocMngTable();
#else
	Common::TypeDef::UFourByte adr;
	if(command->size() >=2)
	{
		command->cutTheFront(2);
		if(command->hexToValue(adr)==true)
		{
			dumpTable(com,(Common::TypeDef::UOneByte *)adr,32);
		}
	}
#endif
	com->releaseReceptionBuffer(command);
	com->sendPrompt();
}

void DumpMemory::dumpTable(Unit::Communication::Com* com,Common::TypeDef::UOneByte * adr,Common::TypeDef::UTwoByte size)
{
	UTwoByte i,j;
	for(i=0; i<size; )
	{
		Common::BasicType::Bytes* line=new Common::BasicType::Bytes(64U);
		if(line==NULL) break;
		
		Common::BasicType::Bytes* adrStr=new Common::BasicType::Bytes(16U);
		Common::BasicType::ValueToStringConverter* cv
			=new Common::BasicType::ValueToStringConverter((Common::TypeDef::UFourByte)adr+i);
		if(adrStr==NULL || cv==NULL) break;
		
		cv->getHexString(*adrStr,8);
		adrStr->push_back(':');
		line->push_back(*adrStr);
		delete adrStr;
		delete cv;
		for(j=0; j<16; j++,i++)
		{
			Common::BasicType::Bytes* value=new Common::BasicType::Bytes(8U);
			Common::BasicType::ValueToStringConverter* cv1
				=new Common::BasicType::ValueToStringConverter((Common::TypeDef::UFourByte)*(adr+i));
			if(value==NULL || cv1==NULL) break;
			
			cv1->getHexString(*value,2);
			if(j==7) {value->push_back('-'); } else { value->push_back(' '); }
			line->push_back(*value);
			delete value;
			delete cv1;
		}
		line->push_back(0xd); com->send(line,false);
	}
}
