OUTPUT_FORMAT("elf32-h8300")
OUTPUT_ARCH(h8300s)
ENTRY("_start")
MEMORY
{
	vectors(r)   : o = 0x200000, l = 0x000200
	v_vectors(r) : o = 0x200200, l = 0x000200
	ram(rwx)     : o = 0x200400, l = (2M-0x404)
	stack(rw)    : o = 0x3ffffc, l = 0x000004
	stack1(rw)   : o = 0xfffbfc, l = 0x000004

}
SECTIONS 				
{
.vectors : { *(.vect) }  > vectors 
.v_vectors : { *(.v_vectors) }  > v_vectors 
/* text : program code */					
.text : {
	*(.text)		
	*(.text.*)
	*(.rodata)
	___ctors = . ;
	*(.ctors)
	___ctors_end = . ;
	___dtors = . ;
	*(.dtors)
	*(.gnu.linkonce.t*)
	*(.gnu.linkonce.r*)
	*(.rodata.*)
	*(.comment*)
	*(.strings)
	___dtors_end = . ;
	 _handler_begin = .;
	 *(.handler) 
	 *(handler) 
	 _handler_end = .;
   	 _etext = . ; 
	} > ram
/* data : Initialized variable */
.data ALIGN(4) : {
	_data_begin = .;
	___data = . ;
	*(.data)
	*(.tiny)
	*(.gnu.linkonce.d*)
	 _edata = .;
	_data_end = .;
	} > ram
/* bss : Variable without initialization */
.bss ALIGN(4) : {
	 _bss_begin = .;
	*(.bss)
	*(COMMON)
	*(.gnu.linkonce.s*)
	 _bss_end   = .;
	/* for stdlib :When the memory is used from the heap,this symbol(_end) is used. */
	_end = .;
	}  > ram
.heap ALIGN(4) : {
	_heap_start = . ;
	_heap_end = (. + 0x8000) ;
	} > ram
.stack  : {
	 _stack_external = . ; 
	}  > stack
.stack1 : {
	 _stack_internal = . ; 
	}  > stack1
}
