OUTPUT_FORMAT("elf32-h8300")
OUTPUT_ARCH(h8300s)
ENTRY("_start")
MEMORY
{
	vectors(r)   : o = 0x000000, l = 0x000200
	rom(rx)      : o = 0x000200, l = (2M-0x200)
	ram1(rwx)    : o = 0x200000, l = 0x050000
	ram(rwx)     : o = 0x250000, l = (2M-0x50004)
	stack(rw)    : o = 0x3ffffc, l = 0x000004
	ram2(rwx)    : o = 0xffec00, l = (0x1000-0x100)
	stack1(rw)   : o = 0xfffbfc, l = 0x000004
}
SECTIONS 				
{
.vectors : { *(.vect) }  > vectors 
/* text : program code */					
.text : {
	*(.text)		
	*(.text.*)
	*(.rodata)
	___ctors = . ;
	*(.ctors)
	___ctors_end = . ;
	___dtors = . ;
	*(.dtors)
	*(.rodata.*)
	*(.gnu.linkonce.t*)
	*(.gnu.linkonce.r*)
	*(.comment*)
	*(.strings)
	___dtors_end = . ;
   	 _etext = . ; 
	} > rom
.handler : AT ( 0x1b0000 ) {
	 _handler_begin = .;
	 *(.handler) 
	 *(handler) 
	 _handler_end = .;
	}  > ram2
/* data : Initialized variable */
.data : AT (  0x1b1000 ){
	_data_begin = .;
	___data = . ;
	*(.data)
	*(.tiny)
	*(.gnu.linkonce.d*)
	*(.gnu.linkonce.s*)
	 _edata = .;
	_data_end = .;
	} > ram1
/* bss : Variable without initialization */
.bss  : {
	 _bss_begin = .;
	*(.bss)
	*(.gnu.linkonce.b*)
	*(COMMON)
	 _bss_end   = .;
	/* for stdlib :When the memory is used from the heap,this symbol(_end) is used. */
	_end = .;
	}  > ram
.heap ALIGN(4) : {
	_heap_start = . ;
	_heap_end = (. + 0x8000) ;
	} > ram
.stack : {
	 _stack_external = . ; 
	}  > stack
.stack1 : {
	 _stack_internal = . ; 
	}  > stack1
}
