///////////////////////////////////////////////////////////
//  WriteRom.cpp
//  Implementation of the Class WriteRom
//  Created on:      29-12-2008 16:11:04
//  Original author: Ueno
///////////////////////////////////////////////////////////

#include "Application/Tibi8Monitor/WriteRom.h"
#include "Common/BasicType/util.h"
#include "Common/BasicType/ValueToStringConverter.h"

using Application::Tibi8Monitor::WriteRom;


WriteRom::WriteRom(Unit::CPUBoard::CPUBoard* pCPUBoard):m_pCPUBoard(pCPUBoard){}
WriteRom::~WriteRom(){}

bool WriteRom::check(const Common::BasicType::Bytes* command){
	bool bRet=false;
	if(command->size()>=1)
	{
		if( ((*command)[0]) =='S')
		{
			bRet=true;
		}
	}
	return bRet;
}


void WriteRom::execute(Unit::Communication::Com* com,Common::BasicType::Bytes* command){
#if defined(SCI_DEBUG_PERFORMANCE1)
		volatile unsigned char * pp;	
		pp=P2DR_ADDR;
		*pp |=0x40;
#endif
//	
//	Common::Util::SFormat::RecordFormat type;
	
	m_SFormat.init(command);
	switch(m_SFormat.getRecordFormat())
	{
		case Common::Util::SFormat::RF_S0 : 
//			rawDisp8Digit(P2DDR_ADDR,P2DR_ADDR,0x0);	// For Debug
			com->echoOff(); 
			Common::Util::SFormat::setNumberOfLine(0);
			Common::Util::SFormat::setReceiving(true);
			break;
		case Common::Util::SFormat::RF_S1 : 
		case Common::Util::SFormat::RF_S2 : 
		case Common::Util::SFormat::RF_S3 : 
			if(Common::Util::SFormat::getReceiving()==true)
			{
				/*
				{
					Common::TypeDef::UTwoByte j;
					Common::BasicType::Bytes* line=new Common::BasicType::Bytes(80U);
					Common::BasicType::Bytes* adrStr=new Common::BasicType::Bytes(16U);
					Common::BasicType::ValueToStringConverter* cv
						=new Common::BasicType::ValueToStringConverter((Common::TypeDef::UFourByte)m_SFormat.getStartAddress());
					cv->getHexString(*adrStr,8);
					adrStr->push_back(':');
					line->push_back(*adrStr);
					delete adrStr;
					delete cv;
					for(j=0; j<m_SFormat.size(); j++)
					{
						Common::BasicType::Bytes* value=new Common::BasicType::Bytes(8U);
						Common::BasicType::ValueToStringConverter* cv1
							=new Common::BasicType::ValueToStringConverter(m_SFormat.getAt(j));
						if(value==NULL || cv1==NULL) break;
			
						cv1->getHexString(*value,2);
						line->push_back(*value);
						delete value;
						delete cv1;
					}
					line->push_back(0xd); com->send(line,false);
				}
				*/
				program();
				// 1Kbytež뤿Ӥˣɽ
				if(Common::Util::SFormat::getNumberOfLine()%64==0)
				{

					Common::BasicType::Bytes* pMark=new Common::BasicType::Bytes(".");
					com->send(pMark,false);
				}
			}
			break;
		case Common::Util::SFormat::RF_S7 : 
		case Common::Util::SFormat::RF_S8 : 
		case Common::Util::SFormat::RF_S9 : 
//			rawDisp8Digit(P2DDR_ADDR,P2DR_ADDR,0x9);	// For Debug
			receiveEnd(com,".",NULL);
			com->echoOn();
			break;
		case Common::Util::SFormat::RF_CHECKSUM_ERROR : 
			receiveEnd(com,"** CheckSum Error **",command);
			break;
		case Common::Util::SFormat::RF_SIZE_ERROR : 
			receiveEnd(com,"** Size Error **",command);
			break;
		default : 
			receiveEnd(com,"** INVALID_SFORMAT **",command);
			break;
	}
	com->releaseReceptionBuffer(command);
#if defined(SCI_DEBUG_PERFORMANCE1)
	*pp &=(~0x40);
#endif
}

void WriteRom::program()
{
	Common::TypeDef::UTwoByte i,size;
	Common::TypeDef::UFourByte addr;
	addr=m_SFormat.getStartAddress();
	size=m_SFormat.size();
	for(i=0; i<size; i++)
	{
		m_pCPUBoard->programOneByte(addr+i,m_SFormat.getAt(i));
	}
}

void WriteRom::receiveEnd(Unit::Communication::Com* com,char *msg,Common::BasicType::Bytes* command)
{
	Common::BasicType::Bytes* pMark;
	if(command != NULL)
	{
		pMark=new Common::BasicType::Bytes(*command);
	}
	else
	{
		pMark=new Common::BasicType::Bytes();
	}
	pMark->push_back(msg,strLen(msg));
	com->send(pMark,true);
	Common::Util::SFormat::setReceiving(false);
}
